#include <Adafruit_NeoPixel.h>
#include <Adafruit_GFX.h>
#include <Adafruit_ILI9341.h>
#include <Fonts/FreeSans12pt7b.h>

#include "colors.h"

#define TFT_CS 9
#define TFT_DC 10
#define BACKGROUND_COLOR	0xDEFB
#define FOREGROUND_COLOR	BLACK

Adafruit_ILI9341 tft(TFT_CS, TFT_DC);

Adafruit_NeoPixel pixels(1, 11, NEO_GRB + NEO_KHZ800);
auto cOff = pixels.Color(0, 0, 0);
auto cGreen = pixels.Color(0, 255, 0);
auto cRed = pixels.Color(255, 0, 0);
auto cBlue = pixels.Color(0, 0, 255);


void
setup()
{
	Serial.begin(115200);
	pixels.begin();
	pixels.clear();
	pixels.show();

	tft.begin();
	tft.setRotation(1);
	tft.setTextSize(1);
	tft.setCursor(0, 8);

	tft.fillScreen(BACKGROUND_COLOR);
	tft.setTextColor(FOREGROUND_COLOR);
  	
  	tft.println(" \\ (define square (x) (* x ))");
	tft.println(" \\ (square 3)");
	tft.println(" 9");
	tft.println(" \\ ");
}


bool
blink(bool on)
{
	if (on) {
		for (int i = 10; i < 255; i++) {
			auto c = pixels.Color(0, (uint8_t)i, 0);
			pixels.setPixelColor(0, c);
			pixels.show();
			delay(4);
		}
		on = false;
	} else {
		for (int i = 255; i > 9; i--) {
			auto c = pixels.Color(0, (uint8_t)i, 0);
			pixels.setPixelColor(0, c);
			pixels.show();
			delay(4);
		}
		on = true;
	}

	return on;
}


void
pixelOn(uint32_t c)
{
	pixels.setPixelColor(0, c);
	pixels.show();
}


void
pixelOff()
{
	pixels.setPixelColor(0, cOff);
	pixels.show();
}


void
loop()
{
	static bool	on = false;

	on = blink(on);
	delayMicroseconds(100);
}
